﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GasolineTanker
{
    public partial class FormMapWithSetGasolineTanker : Form
    {
        private MapWithSetGasolienTankerGeneric<DrawingObjectGasolineTanker, AbstractMap> _mapGasolineTankerCollectionGeneric;
        public FormMapWithSetGasolineTanker()
        {
            InitializeComponent();
        }       
        private void ButtonAddGasolineTanker_Click(object sender, EventArgs e)
        {
            if (_mapGasolineTankerCollectionGeneric == null)
            {
                return;
            }
            FormGasolineTanker form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                DrawingObjectGasolineTanker GasolineTanker = new(form.SelectedGasolineTanker);
                if (_mapGasolineTankerCollectionGeneric + GasolineTanker >= 0)
                {
                    MessageBox.Show("Object added");
                    pictureBox.Image = _mapGasolineTankerCollectionGeneric.ShowSet();
                }
                else
                {
                    MessageBox.Show("Failed to add object");
                }
            }
        }

        private void ButtonRemoveGasolineTanker_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(maskedTextBoxPosition.Text))
            {
                return;
            }
            if (MessageBox.Show("Delete object?", "Removal", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxPosition.Text);
            if (_mapGasolineTankerCollectionGeneric - pos != null)
            {
                MessageBox.Show("Object deleted");
                pictureBox.Image = _mapGasolineTankerCollectionGeneric.ShowSet();
            }
            else
            {
                MessageBox.Show("Failed to delete object");
            }
        }

        private void ButtonShowStorage_Click(object sender, EventArgs e)
        {
            if (_mapGasolineTankerCollectionGeneric == null)
            {
                return;
            }
            pictureBox.Image = _mapGasolineTankerCollectionGeneric.ShowSet();
        }

        private void ButtonShowOnMap_Click(object sender, EventArgs e)
        {
            if (_mapGasolineTankerCollectionGeneric == null)
            {
                return;
            }
            pictureBox.Image = _mapGasolineTankerCollectionGeneric.ShowOnMap();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_mapGasolineTankerCollectionGeneric == null)
            {
                return;
            }
            //получаем имя кнопки
            string name = ((Button)sender)?.Name ?? string.Empty;
            Direction dir = Direction.None;
            switch (name)
            {
                case "keyUp":
                    dir = Direction.Up;
                    break;
                case "keyDown":
                    dir = Direction.Down;
                    break;
                case "keyLeft":
                    dir = Direction.Left;
                    break;
                case "keyRight":
                    dir = Direction.Right;
                    break;
            }
            pictureBox.Image = _mapGasolineTankerCollectionGeneric.MoveObject(dir);
        }

        private void ComboBoxSelectorMap_SelectedIndexChanged(object sender, EventArgs e)
        {
            AbstractMap map = null;
            switch (comboBoxSelectorMap.Text)
            {
                case "Simple map":
                    map = new SimpleMap();
                    break;
                case "Long map":
                    map = new LongMap();
                    break;
            }
            if (map != null)
            {
                _mapGasolineTankerCollectionGeneric = new MapWithSetGasolienTankerGeneric<DrawingObjectGasolineTanker, AbstractMap>(
                    pictureBox.Width, pictureBox.Height, map);
            }
            else
            {
                _mapGasolineTankerCollectionGeneric = null;
            }
        }
    }
}
