﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal class SetGasolineTankerGeneric<T>
        where T : class
    {
		private readonly T[] _places;
		public int Count => _places.Length;
		public SetGasolineTankerGeneric(int count)
		{
			_places = new T[count];
		}
		public int Insert(T gasolineTanker)
		{
			if (_places[Count - 1] == null)
			{
				for (int i = Count - 1; i > 0; i--)
				{
					_places[i] = _places[i - 1];
				}
				_places[0] = gasolineTanker;
				return 0;
			}
			return -1;
		}
		public int Insert(T gasolineTanker, int position)
		{
			if (position < 0 || position >= Count) return -1;
			if (_places[position] == null)
			{
				_places[position] = gasolineTanker;
				return position;
			}
			else
			{
				if (_places[Count - 1] == null)
				{
					for (int i = Count - 1; i > position; i--)
					{
						_places[i] = _places[i - 1];
					}
					_places[position] = gasolineTanker;
					return position;
				}
				return -1;
			}
		}
		public T Remove(int position)
		{
			if (position < 0 || position >= Count) 
				return null;
			if (_places[position] != null)
			{
				T removed = _places[position];
				_places[position] = null;
				if (position < Count - 1)
				{
					for (int k = position; k < Count - 1; k++)
					{
						_places[k] = _places[k + 1];
					}
				}
				return removed;
			}
			return null;
		}
		public T Get(int position)
		{
			if (position >= Count || position < 0)
				return null;

			return _places[position];
		}
	}
}
